#! /usr/bin/env python

# gs6.5 TrueType ۲ ֵ ġϴ α׷
# Hwang, Chideok <hwang@mizi.co.kr> 2001/04/12
#
# CIDFont ̸ ۲ ġ ڷ .
# 

import os, sys

rs_dir = '/usr/share/ghostscript/Resource/'
cidfont_dir = rs_dir + 'CIDFont/'
font_dir = rs_dir + 'Font/'
cmap_dir = rs_dir + 'CMap/'

cmap_list = os.listdir(cmap_dir)
if len(cmap_list) < 1:
	print 'CMap  丮(' + cmap_dir + ') ֽϴ.'
	print 'Ghostscript ѱ ġ  ġ Ǿֳ?'
	sys.exit(1)

cmap_list = ['KSC-EUC-H', 'KSC-EUC-V', 'UniKS-KS-UTF8-H', 'UniKS-KS-UTF8-H']
#cmap_list = os.listdir(cmap_dir)

def gen_cid_font(name, fname):
	cidname = cidfont_dir + name
	if os.path.exists(cidname):
		print ('̹ CID Font(%s)' % cidname) + '  մϴ.'
		print 'ϴ.'
	try:
		f = open(cidname, 'w')
	except IOError, reason:
		print "CID۲(%s)   ϴ." % cidname
		print "sudo ̿Ͻ ƴϸ Ʈ  αϽ "
		print "Ͻñ ٶϴ."
		sys.exit(1)
	f.write("%%!PS-Adobe-3.0 Resource-CIDFont\n")
	f.write("%%" + "BeginResource: CIDFont (%s)\n" % name)
	f.write("%%" + "Title: (%s Adobe Korean1 1)\n" % name)
	f.write("%%Version: 1.0\n")
	f.write("(%s) (%s) freetypecidbuilder\n" % (name, fname))
	f.write("%%EndResource\n")
	f.write("%%EOF\n")

def write_fontfile(font_name, cmap_name):
	full_name = font_name + '-' + cmap_name
	f = open(full_name, 'w')
	f.write("%%!PS-Adobe-3.0 Resource-Font\n");
	f.write("%%" + "DocumentNeededResources: %s (CMap)\n" % cmap_name);
	f.write("%%" + "IncludeResource: %s (CMap)\n" % cmap_name)
	f.write("%%" + "BeginResource: Font (%s)\n" % full_name)
	f.write("/%s\n" % full_name)
	f.write("/%s /CMap findresource\n" % cmap_name)
	f.write("[/%s /CIDFont findresource]\n" % font_name)
	f.write("composefont pop\n");
	f.write("%%EndResource\n")
	f.write("%%EOF\n")

def gen_font(name):
	os.chdir(font_dir)
	for cmap in cmap_list:
		write_fontfile(name, cmap)

if len(sys.argv) != 3 or '-h' in sys.argv:
	print ':' , sys.argv[0] + ' "۲ ̸" "۲ ġ"'
	print ':', sys.argv[0], "Gulim /usr/share/fonts/baekmuk/gulim.ttf"
	print '   ', sys.argv[0], "Batang /opt/winfonts/batang.ttc"
	print '   ', sys.argv[0], "Gungseo /opt/winfonts/batang.ttc:2"
	sys.exit(1)

try: filename = sys.argv[2].split(':')[0]
except: filename = sys.argv[2]

if not os.path.exists(filename):
	print ('۲ (%s)' % sys.argv[2]) + ' ϴ.'
	sys.exit(1)

gen_cid_font(sys.argv[1], sys.argv[2])
gen_font(sys.argv[1])
